#pragma once
#include "stdafx.h"

class FunctionTable
{
public:
	FunctionTable(ptr_transform function)
	{
		fSize = (float)TABLE_SIZE-1;
		float sizeInverse = 1.f/(float)TABLE_SIZE;
		for (int i=0; i<TABLE_SIZE; i++)
		{
			table[i] = function((float)i*sizeInverse);
		}
	}
	~FunctionTable() {}

	float lookup(float in)
	{
		assert(in>=0 && in<=1);
		float mid = in*fSize;
		int low = (int)mid;
		int high = low+1;
		float frac = mid-(float)low;
		low = std::max(0, std::min(low, TABLE_SIZE-1));
		high = std::max(0, std::min(high, TABLE_SIZE-1));
		return (table[low]*(1.f-frac))+(table[high]*(frac));
	}
private:
	float table[TABLE_SIZE];
	float fSize;
};

