#pragma once
class Interpolator
{
public:
	Interpolator() { value = target = inertia = delta = 0; }
	~Interpolator() {}

	void init(float v) { value = target = v; }

	void setTarget(float t)
	{
		target = t;

		if (inertia > 0)
		{
			delta = (target - value) / (float)inertia;
		}
		else
		{
			delta = 0;
			value = target;
		}
	}
	
	// returns true if interpolation already finished
	bool advance()
	{
		if (delta != 0.0f)
		{
			value += delta;
			if (delta > 0)
			{
				if (value >= target)
				{
					value = target;
					delta = 0;
				}
			}
			else
			{
				if (value <= target)
				{
					value = target;
					delta = 0;
				}
			}
			return false;
		}
		return true;
	}
	float value;
	int inertia;

private:
	float target;
	float delta;
};

