
struct float2 {
	
	// constructors
public:
	float2          ( void ) {}
	float2          ( const float2& c ) { v[0] = c.v[0], v[1] = c.v[1]; }
	float2          ( const float a, const float b ) { v[0] = a, v[1] = b; }
	float2          ( const float* a )  { v[0] = a[0], v[1] = a[1]; }
	float2          ( const double* a ) { v[0] = a[0], v[1] = a[1]; }

	// operators
public:
	operator float*( void ) { return &v[0]; }
	operator const float*( void ) const  { return &v[0]; }
	~float2( void ) {}
  
	float2& operator=( const float2& c )
	{ v[0] = c.v[0], v[1] = c.v[1]; return *this; }

	float2 operator+( const float2& c ) const
	{ return float2( v[0] + c.v[0], v[1] + c.v[1] ); }

	float2 operator-( const float2& c ) const
	{ return float2( v[0] - c.v[0], v[1] - c.v[1] ); }

	float2 operator*( const float s ) const
	{ return float2( s * v[0], s * v[1] ); }

	friend float2 operator*( const float s, const float2& c )
	{ return float2( s * c.v[0], s * c.v[1] ); }

	float2 operator/( const float s ) const
	{ return float2( v[0] / s, v[1] / s ); }
  
	float2& operator+=( const float2& c )
	{ v[0] += c.v[0], v[1] += c.v[1]; return *this; }

	float2& operator-=( const float2& c ) 
	{ v[0] -= c.v[0], v[1] -= c.v[1]; return *this; }

	float2& operator*=( const float s ) { v[0] *= s, v[1] *= s; return *this; }

	float2& operator/=( const float s ) { v[0] /= s, v[1] /= s; return *this; }

	float2 operator-( void ) const { return float2( -v[0], -v[1] ); }

	int operator==( const float2& o ) const
	{ return ( v[0] == o.v[0] ) && ( v[1] == o.v[1] ); }

private:
	float v[2];

};